
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..},distance=..0.25] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run tp @s ~ ~ ~
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run scoreboard players remove @s movement 1

execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..,space_id=0},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run function monopoly:system/update_message_targets
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..,space_id=0},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" passed ","color":"gray","italic":true},{"text":"Go","color":"green","italic":true},{"text":".","color":"gray","italic":true}] 

execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..,space_id=0},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run function monopoly:money/go_money
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0..},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id at @s run playsound minecraft:block.amethyst_block.resonate neutral @a ~ ~ ~ 0.3 1.5
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0..},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id at @s run playsound minecraft:block.amethyst_block.resonate neutral @a ~ ~ ~ 0.3
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0..},distance=..0.01,tag=moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id at @s run playsound minecraft:entity.item.pickup neutral @a ~ ~ ~ 0.5 1.3

execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..},distance=..0.01,tag=!moving] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run tag @s add moving
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0},distance=..0.01] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run tag @s remove moving
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0},distance=..0.01] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run function monopoly:movement/space_landed
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=0},distance=..0.01] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id at @s run tp @s ^0.3 ^ ^
scoreboard players reset @e[scores={movement=..0}] movement
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..},distance=..0.01,tag=!move_backwards] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run scoreboard players add @s space_id 1
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..},distance=..0.01,tag=move_backwards] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run scoreboard players remove @s space_id 1
scoreboard players remove @e[scores={space_id=40..}] space_id 40
scoreboard players add @e[scores={space_id=..-1}] space_id 40
execute as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1..}] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id facing entity @s eyes positioned as @s positioned ~ 100 ~ rotated ~-180 0 run tp @s ^ ^ ^0.24 ~ ~


execute as @e[tag=token,scores={movement=..1},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"1","bold":true}'}
execute as @e[tag=token,scores={movement=2},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"2","bold":true}'}
execute as @e[tag=token,scores={movement=3},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"3","bold":true}'}
execute as @e[tag=token,scores={movement=4},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"4","bold":true}'}
execute as @e[tag=token,scores={movement=5},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"5","bold":true}'}
execute as @e[tag=token,scores={movement=6},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"6","bold":true}'}
execute as @e[tag=token,scores={movement=7},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"7","bold":true}'}
execute as @e[tag=token,scores={movement=8},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"8","bold":true}'}
execute as @e[tag=token,scores={movement=9},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"9","bold":true}'}
execute as @e[tag=token,scores={movement=10},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"10","bold":true}'}
execute as @e[tag=token,scores={movement=11},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"11","bold":true}'}
execute as @e[tag=token,scores={movement=12..},tag=!hide_count] run data merge entity @s {CustomName:'{"text":"12","bold":true}'}

execute as @e[tag=token,scores={movement=-1..},tag=!hide_count] run data merge entity @s {CustomNameVisible:1}
execute as @e[tag=token] unless score @s movement matches -1.. run data merge entity @s {CustomNameVisible:0}
execute as @e[tag=token] unless score @s movement matches -1.. run data modify entity @s CustomName set value ''

execute if entity @e[tag=token,team=mooshroom,scores={movement=1..}] run team modify mooshroom collisionRule never
execute unless entity @e[tag=token,team=mooshroom,scores={movement=1..}] run team modify mooshroom collisionRule always
execute if entity @e[tag=token,team=cat,scores={movement=1..}] run team modify cat collisionRule never
execute unless entity @e[tag=token,team=cat,scores={movement=1..}] run team modify cat collisionRule always
execute if entity @e[tag=token,team=frog,scores={movement=1..}] run team modify frog collisionRule never
execute unless entity @e[tag=token,team=frog,scores={movement=1..}] run team modify frog collisionRule always
execute if entity @e[tag=token,team=goat,scores={movement=1..}] run team modify goat collisionRule never
execute unless entity @e[tag=token,team=goat,scores={movement=1..}] run team modify goat collisionRule always
execute if entity @e[tag=token,team=axolotl,scores={movement=1..}] run team modify axolotl collisionRule never
execute unless entity @e[tag=token,team=axolotl,scores={movement=1..}] run team modify axolotl collisionRule always
execute if entity @e[tag=token,team=pig,scores={movement=1..}] run team modify pig collisionRule never
execute unless entity @e[tag=token,team=pig,scores={movement=1..}] run team modify pig collisionRule always