
#scoreboard players set turn_state game_state -1
title @a times 0 40 20
title @a title ""

execute as @e[tag=token,scores={payment_to_pending=1..}] run scoreboard players operation @s payment_to = @s payment_to_pending
function monopoly:system/update_message_targets
execute as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = current_controller player_id unless score @s payment_to matches 1..6 run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" declared bankruptcy.","color":"gray","italic":true}] 
execute as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = current_controller player_id if score @s payment_to matches 1..6 at @s as @e[scores={player_id=1..},tag=msg_sys_entity] unless score @s player_id = current_controller player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_entity,sort=nearest,limit=1]","italic":true},{"text":" declared bankruptcy to ","color":"gray","italic":true},{"selector":"@s","italic":true},{"text":" declared bankruptcy to ","color":"gray","italic":true}] 

execute if score player_count_minus_one constants matches 2.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @a title {"selector":"@s"}
execute if score player_count_minus_one constants matches 2.. run title @a subtitle {"text":"Has declared bankruptcy!","color":"dark_red","bold":true}
execute if score player_count_minus_one constants matches 2.. as @a at @s run playsound minecraft:entity.wither.spawn master @s ~ ~ ~ 0.55 1
execute if score player_count_minus_one constants matches 2.. as @a at @s run playsound minecraft:entity.zombie_villager.cure master @s ~ ~1 ~ 0.25 0.8
execute if score player_count_minus_one constants matches 2.. as @a at @s run playsound minecraft:block.beacon.deactivate master @s ~ ~1 ~ 2 0.5
execute if score player_count_minus_one constants matches 2.. as @a at @s run playsound minecraft:block.beacon.deactivate master @s ~ ~1 ~ 2 0.6
execute if score player_count_minus_one constants matches 2.. as @a at @s run playsound minecraft:block.beacon.deactivate master @s ~ ~1 ~ 2 0.8

execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run tag @s add bankrupt_target

execute if score player_count_minus_one constants matches 2.. as @e[tag=token,scores={player_id=1..},tag=!bankrupt_target] if score @s player_id = @e[tag=token,scores={player_id=1..},tag=bankrupt_target,limit=1] payment_to run tag @s add debt_winner
execute if score player_count_minus_one constants matches 2.. if entity @e[tag=token,tag=debt_winner] as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players operation @e[tag=token,tag=debt_winner,limit=1] payment -= @s money
execute if score player_count_minus_one constants matches 2.. as @e[type=marker,tag=space,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run particle poof ^ ^0.5 ^2.5 0.2 0.2 0.2 0.1 20
execute if score player_count_minus_one constants matches 2.. if entity @e[tag=token,tag=debt_winner] as @e[type=marker,tag=space,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players operation @s player_id = @e[tag=token,tag=debt_winner,limit=1] player_id
execute if score player_count_minus_one constants matches 2.. if entity @e[tag=token,tag=debt_winner] if score jail_card_chance player_id = current_controller player_id run scoreboard players operation jail_card_chance player_id = @e[tag=token,tag=debt_winner,limit=1] player_id
execute if score player_count_minus_one constants matches 2.. if entity @e[tag=token,tag=debt_winner] if score jail_card_community_chest player_id = current_controller player_id run scoreboard players operation jail_card_community_chest player_id = @e[tag=token,tag=debt_winner,limit=1] player_id

execute if score player_count_minus_one constants matches 2.. unless entity @e[tag=token,tag=debt_winner] as @e[type=marker,tag=space,scores={player_id=1..,property_state=1..}] if score @s player_id = current_controller player_id run scoreboard players set @s property_state 0
execute if score player_count_minus_one constants matches 2.. unless entity @e[tag=token,tag=debt_winner] as @e[type=marker,tag=space,scores={player_id=1..}] if score @s player_id = current_controller player_id run tag @s add needs_auction
execute if score player_count_minus_one constants matches 2.. unless entity @e[tag=token,tag=debt_winner] as @e[type=marker,tag=space,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players reset @s player_id
execute if score player_count_minus_one constants matches 2.. unless entity @e[tag=token,tag=debt_winner] if score jail_card_chance player_id = current_controller player_id run scoreboard players reset jail_card_chance player_id
execute if score player_count_minus_one constants matches 2.. unless entity @e[tag=token,tag=debt_winner] if score jail_card_community_chest player_id = current_controller player_id run scoreboard players reset jail_card_community_chest player_id

execute if score player_count_minus_one constants matches 2.. as @e[tag=token,scores={player_id=1..,payment_to=7}] if score @s player_id = current_controller player_id at @s as @e[tag=token,scores={player_id=1..},distance=0.01..] run scoreboard players operation @s payment -= @e[tag=token,scores={player_id=1..,payment_to=7},sort=nearest,limit=1] money
execute if score player_count_minus_one constants matches 2.. as @e[tag=token,scores={player_id=1..,payment_to=7}] if score @s player_id = current_controller player_id at @s as @e[tag=token,scores={player_id=1..},distance=0.01..] run scoreboard players operation @s payment /= player_count_minus_one constants

execute if score player_count_minus_one constants matches 2.. as @e[tag=token,scores={player_id=1..,payment_to=8}] if score @s player_id = current_controller player_id run scoreboard players operation free_parking money += @e[tag=token,scores={player_id=1..,payment_to=8},sort=nearest,limit=1] money
execute if score player_count_minus_one constants matches 2.. as @e[tag=token,scores={player_id=1..,payment_to=8}] if score @s player_id = current_controller player_id run function monopoly:board/free_parking_money_visual


execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:entity.generic.explode neutral @a ~ ~ ~ 0.8 1.5 0.2
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run particle minecraft:flash ~ ~0.2 ~ 0 0 0 0 1 force
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run particle minecraft:large_smoke ~ ~0.2 ~ 0 0 0 0.1 20
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run kill @s

scoreboard players set turn_state game_state 1
execute if score pending_turn_state game_state matches 1.. run scoreboard players operation turn_state game_state = pending_turn_state game_state
execute if score pending_turn_state game_state matches ..-1 run scoreboard players operation turn_state game_state = pending_turn_state game_state
scoreboard players operation current_controller player_id = current_turn player_id

execute unless score player_count_minus_one constants matches 2.. run function monopoly:system/declare_winner

function monopoly:board/update_property_visuals
tag @e[tag=debt_winner] remove debt_winner
tag @a[scores={player_id=1..}] add update_inventory
tag @a[scores={player_id=1..}] add disable_inventory_checks

tag @e[tag=bankrupt_target] remove bankrupt_target