
tag @e[type=marker,tag=space,tag=trading,tag=monopoly] remove monopoly
execute as @e[type=marker,tag=space,tag=trading] at @s run particle poof ^ ^0.5 ^2.5 0.2 0.2 0.2 0.1 20
execute as @e[type=marker,tag=space,tag=trading] if score @s player_id = current_controller player_id run tag @s add trade_controller
execute as @e[type=marker,tag=space,tag=trading] if score @s player_id = trade_target player_id run scoreboard players operation @s player_id = current_controller player_id
execute as @e[type=marker,tag=space,tag=trading,tag=!trade_controller] if score @s player_id = current_controller player_id at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" obtained ","color":"gray","italic":true},{"selector":"@e[type=marker,tag=space,sort=nearest,limit=1]","italic":true},{"text":".","color":"gray","italic":true}] 


execute as @e[type=marker,tag=space,tag=trading,tag=trade_controller] run scoreboard players operation @s player_id = trade_target player_id
execute as @e[type=marker,tag=space,tag=trading,tag=trade_controller] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[type=marker,tag=trade_controller,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" obtained ","color":"gray","italic":true},{"selector":"@e[type=marker,tag=space,sort=nearest,limit=1]","italic":true},{"text":".","color":"gray","italic":true}] 
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = trade_money player_id run tag @s add trade_payer
execute as @e[tag=token,scores={player_id=1..},tag=trade_payer] run scoreboard players operation @s payment += trade_amount money
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id unless score @s player_id = trade_money player_id run scoreboard players operation @e[tag=token,scores={player_id=1..},tag=trade_payer] payment_to = @s player_id
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = trade_target player_id unless score @s player_id = trade_money player_id run scoreboard players operation @e[tag=token,scores={player_id=1..},tag=trade_payer] payment_to = @s player_id
tag @e[tag=trade_payer] remove trade_payer

execute if score offering_chance game_state matches 1.. if score jail_card_chance player_id = current_controller player_id run scoreboard players set jail_card_chance player_id 999
execute if score offering_chance game_state matches 1.. if score jail_card_chance player_id = trade_target player_id run scoreboard players operation jail_card_chance player_id = current_controller player_id
execute if score offering_chance game_state matches 1.. if score jail_card_chance player_id matches 999 run scoreboard players operation jail_card_chance player_id = trade_target player_id
execute if score offering_chance game_state matches 1.. as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = jail_card_chance player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now owns a ","color":"gray","italic":true},{"text":"Get Out of Jail Free Card","color":"dark_purple","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score offering_community_chest game_state matches 1.. if score jail_card_community_chest player_id = current_controller player_id run scoreboard players set jail_card_community_chest player_id 999
execute if score offering_community_chest game_state matches 1.. if score jail_card_community_chest player_id = trade_target player_id run scoreboard players operation jail_card_community_chest player_id = current_controller player_id
execute if score offering_community_chest game_state matches 1.. if score jail_card_community_chest player_id matches 999 run scoreboard players operation jail_card_community_chest player_id = trade_target player_id
execute if score offering_community_chest game_state matches 1.. as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = jail_card_community_chest player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now owns a ","color":"gray","italic":true},{"text":"Get Out of Jail Free Card","color":"dark_purple","italic":true},{"text":".","color":"gray","italic":true}] 

kill @e[tag=p_trade_entity]

tag @a add hide_money_text

tag @e[tag=trade_controller] remove trade_controller

execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s times 0 30 20
execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s title ""
execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s subtitle {"text":"Trade Accepted!","color":"green","bold":true,"underlined":true}
execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s times 0 30 20
execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s title ""
execute if score counter_offer game_state matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s subtitle {"text":"Trade Accepted!","color":"green","bold":true,"underlined":true}

scoreboard players reset trade_target player_id


scoreboard players operation current_controller player_id = previous_controller player_id
scoreboard players operation turn_state game_state = previous_turn_state game_state
scoreboard players reset previous_controller player_id
scoreboard players reset previous_turn_state game_state
scoreboard players reset counter_offer game_state
scoreboard players reset offering_chance game_state
scoreboard players reset offering_community_chest game_state
scoreboard players reset trade_amount money
scoreboard players reset trade_money player_id

execute as @a at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.6 2
execute as @a at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 2 2
function monopoly:board/update_property_visuals
tag @e[tag=trading] remove trading
tag @a add update_inventory
tag @a add disable_inventory_checks
