
tag @e[type=marker,tag=space,scores={space_type=1..8}] add check_monopoly
execute as @e[type=marker,tag=space,tag=check_monopoly] at @s as @e[type=marker,tag=space,distance=0.01..] if score @s space_type = @e[type=marker,tag=space,sort=nearest,limit=1] space_type unless score @s player_id = @e[type=marker,tag=space,sort=nearest,limit=1] player_id run tag @e[type=marker,tag=space,sort=nearest,limit=1] remove check_monopoly
tag @e[type=marker,tag=space,tag=!check_monopoly,tag=monopoly] remove monopoly

execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] as @a at @s run playsound minecraft:ui.toast.challenge_complete master @s ~ ~1 ~ 1 1.6
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] at @s run particle flash ~ ~ ~ 0 0 0 0 1 force
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] at @s run particle minecraft:firework ~0 ~ ~ 0.3 0 0.3 0.2 100

execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] run title @a times 2 60 20
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] run title @a title ""
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=1}] run title @a subtitle {"text":"Color Set Complete!","color":"dark_red"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=2}] run title @a subtitle {"text":"Color Set Complete!","color":"aqua"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=3}] run title @a subtitle {"text":"Color Set Complete!","color":"light_purple"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=4}] run title @a subtitle {"text":"Color Set Complete!","color":"gold"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=5}] run title @a subtitle {"text":"Color Set Complete!","color":"red"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=6}] run title @a subtitle {"text":"Color Set Complete!","color":"yellow"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=7}] run title @a subtitle {"text":"Color Set Complete!","color":"green"}
execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=8}] run title @a subtitle {"text":"Color Set Complete!","color":"blue"}

execute if entity @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly] run function monopoly:system/update_message_targets

execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=1},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Brown Properties","color":"dark_red","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=2},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Aqua Properties","color":"aqua","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=3},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Magenta Properties","color":"light_purple","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=4},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Orange Properties","color":"gold","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=5},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Red Properties","color":"red","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=6},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Yellow Properties","color":"yellow","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=7},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Green Properties","color":"green","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,tag=check_monopoly,tag=!monopoly,scores={space_type=8},limit=1] at @s as @e[scores={player_id=1..},tag=msg_sys_entity] if score @s player_id = @e[tag=space,type=marker,sort=nearest,limit=1] player_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" now has a Monopoly on ","color":"gray","italic":true},{"text":"Blue Properties","color":"blue","italic":true},{"text":".","color":"gray","italic":true}]

tag @e[type=marker,tag=space,tag=check_monopoly] add monopoly

tag @e[type=marker,tag=space,tag=check_monopoly] remove check_monopoly