
scoreboard players set turn_state game_state 6
scoreboard players set action_delay timer 8

execute as @e[type=item,tag=card,tag=!registered] at @s run playsound minecraft:block.note_block.bass block @a ~ ~1 ~ 0.6 1.8
execute as @e[type=item,tag=card,tag=!registered] at @s run playsound minecraft:block.note_block.bass block @a ~ ~1 ~ 0.6 0.9
execute as @e[type=item,tag=card,tag=!registered] at @s run summon minecraft:text_display ~ ~0.7 ~ {Tags:["card_text","board_icon"],text:'{"text":"Loading...","color":"gray"}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},billboard:"center",line_width:128,shadow:1b,background:0}

execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 1 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Get Out of Outpost Free","color":"dark_purple","extra":[{"text":" This card may be kept until needed or sold.","color":"yellow"}]}'}
execute if score double_go_rule game_state matches 1.. if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 2 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to ","color":"yellow","extra":[{"text":"GO","color":"green","bold":true},{"text":" (Collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"400","color":"gold"},{"text":")"}]}',line_width:100}
execute unless score double_go_rule game_state matches 1.. if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 2 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to ","color":"yellow","extra":[{"text":"GO","color":"green","bold":true},{"text":" (Collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"200","color":"gold"},{"text":")"}]}',line_width:100}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 3 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to the ","color":"yellow","extra":[{"text":"Nether Fortress","color":"red","bold":true},{"text":" If you pass "},{"text":"GO","color":"green","bold":true},{"text":" collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"200","color":"gold"}]}',line_width:100}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 4 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to the ","color":"yellow","extra":[{"text":"Mushroom Islands","color":"light_purple","bold":true},{"text":" If you pass "},{"text":"GO","color":"green","bold":true},{"text":" collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"200","color":"gold"}]}',line_width:110}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 5..6 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to the nearest ","color":"yellow","extra":[{"text":"Station","color":"dark_green","bold":true},{"text":" If owned, pay the owner "},{"text":"twice","color":"gold"},{"text":" the rental to which they are otherwise entitled"}]}',line_width:165}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 7 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to the nearest ","color":"yellow","extra":[{"text":"Source","color":"dark_aqua","bold":true},{"text":" If owned, pay the owner "},{"text":"ten times","color":"gold"},{"text":" the amount you last rolled"}]}',line_width:169}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 8 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to the ","color":"yellow","extra":[{"text":"End City","color":"blue","bold":true}]}',line_width:100}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 9 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Fished out Enchanted Book ","color":"yellow","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"50","color":"gold"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 10 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Go back ","color":"yellow","extra":[{"text":"3","color":"gold"},{"text":" spaces"}]}'}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 11 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"You looted an Ancient City ","color":"yellow","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"150","color":"gold"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 12 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Take a trip to the ","color":"yellow","extra":[{"text":" Boat Station ","color":"dark_green","bold":true},{"text":" If you pass "},{"text":"GO","color":"green","bold":true},{"text":" collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"200","color":"gold"}]}',line_width:90}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 13 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Horse fell into a cavern ","color":"yellow","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"15","color":"gold"}]}'}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 14 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"You failed to defend against a Pillager raid For each House ","color":"yellow","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"25","color":"gold"},{"text":" For each Hotel "},{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"100","color":"gold"}]}'}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 15 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"You crafted new equipment for everyone ","color":"yellow","extra":[{"text":"Pay each player ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"50","color":"gold"}]}',line_width:125}
execute if entity @e[type=item,tag=card,tag=!registered,tag=chance] as @e[type=marker,tag=chance_card] if score @s card_order matches ..1 if score @s card_id matches 16 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Go to ","color":"yellow","extra":[{"text":"Pillager Outpost","color":"dark_red","bold":true},{"text":" Do not pass "},{"text":"GO","color":"green","bold":true},{"text":", do not collect "},{"text":"D","bold":true,"strikethrough":true,"color":"gold"},{"text":"200","color":"gold"}]}'}


execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 1 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Get Out of Outpost Free","color":"dark_purple","extra":[{"text":" This card may be kept until needed or sold","color":"aqua"}]}'}
execute if score double_go_rule game_state matches 1.. if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 2 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to ","color":"aqua","extra":[{"text":"GO","color":"green","bold":true},{"text":" (Collect "},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"400","color":"dark_aqua"},{"text":")"}]}',line_width:100}
execute unless score double_go_rule game_state matches 1.. if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 2 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Advance to ","color":"aqua","extra":[{"text":"GO","color":"green","bold":true},{"text":" (Collect "},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"200","color":"dark_aqua"},{"text":")"}]}',line_width:100}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 3 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Duplicated Smithing Templates ","color":"aqua","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"50","color":"dark_aqua"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 4 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Found buried treasure ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"50","color":"dark_aqua"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 5 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Returned from mining expedition ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"200","color":"dark_aqua"}]}',line_width:170}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 6 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Fortune III on pickaxe ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"100","color":"dark_aqua"}]}'}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 7 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Defeated a Wither ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"100","color":"dark_aqua"}]}',line_width:115}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 8 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Harvested wheat field ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"20","color":"dark_aqua"}]}'}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 9 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Built communal enchanting station ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"10","color":"dark_aqua"},{"text":" from every player","color":"green"}]}',line_width:170}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 10 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Reclaimed dropped inventory ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"100","color":"dark_aqua"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 11 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Failed Netherite trip ","color":"aqua","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"100","color":"dark_aqua"}]}',line_width:110}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 12 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Creeper damages ","color":"aqua","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"50","color":"dark_aqua"}]}',line_width:100}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 13 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Traded with Villager ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"25","color":"dark_aqua"}]}',line_width:110}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 14 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"A player griefed your village  For each House ","color":"aqua","extra":[{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"40 ","color":"dark_aqua"},{"text":" For each Hotel "},{"text":"Pay ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"115","color":"dark_aqua"}]}',line_width:150}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 15 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"You won second place in a building contest ","color":"aqua","extra":[{"text":"Collect ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"10","color":"dark_aqua"}]}',line_width:120}
execute if entity @e[type=item,tag=card,tag=!registered,tag=community_chest] as @e[type=marker,tag=community_chest_card] if score @s card_order matches ..1 if score @s card_id matches 16 as @e[type=text_display,tag=card_text] run data merge entity @s {text:'{"text":"Go to ","color":"aqua","extra":[{"text":"Pillager Outpost","color":"dark_red","bold":true},{"text":" Do not pass "},{"text":"GO","color":"green","bold":true},{"text":", do not collect "},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"text":"200","color":"dark_aqua"}]}'}


tag @e[type=item,tag=card,tag=!registered] add registered



# CHANCE CARDS
# 1   Get Out of Jail Free
# 2   Advance to Go (Collect $200)
# 3   Advance to Illinois Avenue. If you pass Go, collect $200
# 4   Advance to St. Charles Place. If you pass Go, collect $200
# 5   Advance to the nearest Railroad. If unowned, you may buy it from the Bank. If owned, pay wonder twice the rental to which they are otherwise entitled
# 6   Advance to the nearest Railroad. If unowned, you may buy it from the Bank. If owned, pay wonder twice the rental to which they are otherwise entitled
# 7   Advance token to nearest Utility. If unowned, you may buy it from the Bank. If owned, throw dice and pay owner a total ten times amount thrown.
# 8   Advance to Boardwalk
# 9   Fished out mending book, collect $50
# 10  Go Back 3 Spaces
# 11  You looted an ancient city, collect $150
# 12  Take a trip to Reading Railroad. If you pass Go, collect $200
# 13  Your horse fell into cavern, pay $15
# 14  Your failed to defeat a raid, for each house pay $25, for each hotel pay $100
# 15  You crafted new equipment for everyone, pay each player $50
# 16  Go to Jail. Go directly to Jail, do not pass Go, do not collect $200

# COMMUNITY CHEST CARDS
# 1   Get Out of Jail Free
# 2   Advance to Go (Collect $200)
# 3   Duplicated armor trims, pay $50			
# 4   Burried treasure chest, collect $50
# 5   Returned from your mining trip, collect $200
# 6   Enchanted your pickaxe with Fortune III, collect $100
# 7   Defeated the wither, collect $100
# 8   Harvested wheat field, collect $20
# 9   You built a communal enchantment table, collect $10 from every player
# 10  You found your last death point, collect $100
# 11  Failed netherite trip, pay $100
# 12  Creeper damages, pay $50
# 13  Traded with villager, collect 25$
# 14  A player griefed your village, for each house pay $40, for each hotel pay $115
# 15  You won second place in a building contest, collect $10
# 16  Go to Jail. Go directly to jail, do not pass Go, do not collect $200
